local StoneGateV5 = ...

-- Apply building asset processor
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationKeepPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationCrenation.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationMainPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationSmallSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/machicolations/machicolationOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register materials
function registerMaterial(_fbxName, _assetName)
    function registerColor(_color, _assetColor)
        StoneGateV5:registerAssetId("models/machicolations/machicolation" .. _fbxName .. ".fbx/Materials/" .. _color .. "Roof", StoneGateSetPrefix .. "_MACHICOLATION_" .. _assetName .. "_" .. _assetColor .. "_ROOF_MATERIAL")
    end
    registerColor("red", "RED")
    registerColor("blue", "BLUE")
    registerColor("brown", "BROWN")
    registerColor("grey", "GREY")
    registerColor("grey2", "GREY2")
end

registerMaterial("KeepPlatform", "KEEP")
registerMaterial("MainPlatform", "MAIN")
registerMaterial("SmallSquaredTower", "SST")
registerMaterial("SmallGate", "SGATE")
registerMaterial("OctogonalTower", "OTOWER")

function registerMachicolationPart(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV5:registerAssetId("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set machicolation platform part
    StoneGateV5:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })

    StoneGateV5:registerPrefabComponent("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR"
    })
end


function registerMachicolationPartMajor(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV5:registerAssetId("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set machicolation platform part
    StoneGateV5:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })
end

registerMachicolationPart( "machicolationKeepPlatform", "step_4_Keep_MachicolationC", "MACHICOLATION_KEEP_C", { 0, 0 } )
registerMachicolationPart( "machicolationKeepPlatform", "step_4_Keep_MachicolationCP", "MACHICOLATION_KEEP_C_P", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation34", "MACHICOLATION_CRENATION34", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation40R", "MACHICOLATION_CRENATION40R", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation40L", "MACHICOLATION_CRENATION40L", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation50", "MACHICOLATION_CRENATION50", { 0, 0 } )
registerMachicolationPart( "machicolationKeepPlatform", "step_6_Keep_MachicolationRoofC", "MACHICOLATION_KEEP_ROOF_C", { 0, 0 } )
registerMachicolationPart( "machicolationMainPlatform", "step_4_Main_MachicolationD", "MACHICOLATION_MAIN_D", { 0, 0 } )
registerMachicolationPart( "machicolationMainPlatform", "step_4_Main_MachicolationDP", "MACHICOLATION_MAIN_D_P", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation54", "MACHICOLATION_CRENATION54", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation60R", "MACHICOLATION_CRENATION60R", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation60L", "MACHICOLATION_CRENATION60L", { 0, 0 } )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation70", "MACHICOLATION_CRENATION70", { 0, 0 } )
registerMachicolationPart( "machicolationMainPlatform", "step_6_Main_MachicolationRoofD", "MACHICOLATION_MAIN_ROOF_D", { 0, 0 } )
registerMachicolationPartMajor( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationA", "MACHICOLATION_SST_RAMPART_A", { 0, 0 } )
registerMachicolationPartMajor( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationB", "MACHICOLATION_SST_RAMPART_B", { 0, 0 } )
registerMachicolationPartMajor( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationAP", "MACHICOLATION_SST_RAMPART_AP", { 0, 0 } )
registerMachicolationPartMajor( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationBP", "MACHICOLATION_SST_RAMPART_BP", { 0, 0 } )
registerMachicolationPartMajor( "machicolationSmallSquaredTower", "step_6_Sst_RoofMA", "MACHICOLATION_SST_ROOF_A", { 0, 0 } )
registerMachicolationPartMajor( "machicolationSmallSquaredTower", "step_6_Sst_RoofMB", "MACHICOLATION_SST_ROOF_B", { 0, 0 } )
registerMachicolationPartMajor( "machicolationSmallSquaredTower", "step_6_Sst_RoofMD", "MACHICOLATION_SST_ROOF_D", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_4_SGate_MachicolationA", "SGATE_MACHICOLATION_A", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_4_SGate_MachicolationB", "SGATE_MACHICOLATION_B", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_5_SGate_MachicolationClosingL", "SGATE_MACHICOLATION_CLOSING_L", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_5_SGate_MachicolationClosingR", "SGATE_MACHICOLATION_CLOSING_R", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_4_SGate_WoodenRoofA", "SGATE_MACHICOLATION_WOODEN_ROOF_A", { 0, 0 } )
registerMachicolationPart( "machicolationSmallGate","step_4_SGate_StoneRoofA", "SGATE_MACHICOLATION_STONE_ROOF_A", { 0, 0 } )
registerMachicolationPart( "machicolationOctogonalTower","step_4_Octogonal_Machicolation", "OTOWER_MACHICOLATION", { 0, 0 } )
registerMachicolationPart( "machicolationOctogonalTower","step_4_Octogonal_MachicolationB", "OTOWER_MACHICOLATION_B", { 0, 0 } )
registerMachicolationPart( "machicolationOctogonalTower","step_6_Octogonal_MachicolationRoof", "OTOWER_MACHICOLATION_ROOF", { 0, 0 } )
